Name:           incus
Version:        6.12.0
Release:        1%{?dist}
Summary:        Incus - container and VM manager

### IMPORTANT:
# wget https://go.dev/dl/go1.24.2.linux-amd64.tar.gz
# tar -C /usr/local -xzf go1.24.2.linux-amd64.tar.gz
# export PATH=/usr/local/go/bin:$PATH

License:        Apache-2.0
URL:            https://github.com/lxc/incus
Source0:        https://github.com/lxc/incus/archive/refs/tags/incus-6.12.0.tar.gz
Source1:        shutdown
Source2:        _incus
Source3:        incus.bash-completion
Source4:        incus.service
Source5:        incus.socket
Source6:        incus-startup.service
Source7:        incus-user.service
Source8:        incus-user.socket
Source9:        incus_config.yaml
Source11:       incus.sh
Source12:       incus_logrotate
Source13:       incus_openssl.conf
Patch01:        qemu-runas-fix.patch
Patch02:        qemu_virtio-fs.patch

BuildRequires:  golang
BuildRequires:  cowsql-devel
BuildRequires:  sqlite-devel
BuildRequires:  libcap-devel
BuildRequires:  libacl-devel
BuildRequires:  libattr-devel
BuildRequires:  systemd-devel
BuildRequires:  lxc-devel
BuildRequires:  libseccomp-devel
BuildRequires:  git

Provides:       incus-selinux
Provides:       incus-client
Provides:       incus-agent
Provides:       incus-tools
Provides:       incus(x86-64) = %{version}-%{release}
Obsoletes:      incus-tools < 6.12.0
Obsoletes:      incus-client < 6.12.0
Obsoletes:      incus-agent < 6.12.0
Obsoletes:      incus-selinux < 6.12.0

%description
Incus is a system container and VM manager.

%prep
%setup -n incus-6.12.0
#%patch01 -p0
#%patch02 -p0

%build
export PATH=/usr/local/go/bin:$PATH
export CGO_ENABLED=1
export GOPATH=%{_builddir}/go
export GOBIN=%{_builddir}/go/bin
mkdir -p %{_builddir}/go/bin
mkdir -p %{_builddir}/go/src/github.com/lxc
ln -s %{_builddir}/incus-6.12.0 %{_builddir}/go/src/github.com/lxc/incus

# Build the binaries
cd %{_builddir}/go/src/github.com/lxc/incus
go build -v -o %{_builddir}/go/bin/incusd ./cmd/incusd
go build -v -o %{_builddir}/go/bin/incus ./cmd/incus
go build -v -o %{_builddir}/go/bin/incus-simplestreams ./cmd/incus-simplestreams
go build -v -o %{_builddir}/go/bin/incus-benchmark ./cmd/incus-benchmark
go build -v -o %{_builddir}/go/bin/incus-user ./cmd/incus-user
go build -v -o %{_builddir}/go/bin/lxc-to-incus ./cmd/lxc-to-incus
go build -v -o %{_builddir}/go/bin/lxd-to-incus ./cmd/lxd-to-incus
go build -v -o %{_builddir}/go/bin/fuidshift ./cmd/fuidshift

export CGO_ENABLED=0
export GOOS=linux
export GOARCH=amd64
go build -a -tags 'netgo' -ldflags '-extldflags "-static"' -v -o %{_builddir}/go/bin/incus-agent ./cmd/incus-agent
go build -a -tags 'netgo' -ldflags '-extldflags "-static"' -v -o %{_builddir}/go/bin/incus-migrate ./cmd/incus-migrate

%install
# Install binaries
mkdir -p %{buildroot}/usr/bin
mkdir -p %{buildroot}/usr/libexec/incus
install -m 0755 %{_builddir}/go/bin/incusd %{buildroot}/usr/libexec/incus/incusd
install -m 0755 %{_builddir}/go/bin/incus %{buildroot}/usr/bin/incus
install -m 0755 %{_builddir}/go/bin/incus-agent %{buildroot}/usr/bin/incus-agent
install -m 0755 %{_builddir}/go/bin/incus-migrate %{buildroot}/usr/bin/incus-migrate
install -m 0755 %{_builddir}/go/bin/incus-simplestreams %{buildroot}/usr/libexec/incus/incus-simplestreams
install -m 0755 %{_builddir}/go/bin/incus-benchmark %{buildroot}/usr/bin/incus-benchmark
install -m 0755 %{_builddir}/go/bin/incus-user %{buildroot}/usr/libexec/incus/incus-user
install -m 0755 %{_builddir}/go/bin/lxc-to-incus %{buildroot}/usr/libexec/incus/lxc-to-incus
install -m 0755 %{_builddir}/go/bin/lxd-to-incus %{buildroot}/usr/libexec/incus/lxd-to-incus
mkdir -p %{buildroot}/usr/bin
install -m 0755 %{_builddir}/go/bin/fuidshift %{buildroot}/usr/bin/fuidshift

# Install openssl.cnf:
mkdir -p %{buildroot}/home/incus
install -m 0644 %{SOURCE13} %{buildroot}/home/incus/openssl.cnf

# Install logrotate:
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
install -m 0644 %{SOURCE12} %{buildroot}%{_sysconfdir}/logrotate.d/incus

# Install incus YAML config:
mkdir -p %{buildroot}/root
install -m 0644 %{SOURCE9} %{buildroot}/root/incus_config.yaml

# Install migrate binary:
install -m 0755 %{_builddir}/go/bin/incus-migrate %{buildroot}/usr/bin/bin.linux.incus-migrate.x86_64

# Install Incus Profile:
mkdir -p %{buildroot}/etc/profile.d
install -m 0755 %{SOURCE11} %{buildroot}/etc/profile.d/incus.sh

# Install systemd unit files
mkdir -p %{buildroot}/usr/lib/systemd/system
install -m 0644 %{SOURCE4} %{buildroot}/usr/lib/systemd/system/incus.service
install -m 0644 %{SOURCE5} %{buildroot}/usr/lib/systemd/system/incus.socket
install -m 0644 %{SOURCE6} %{buildroot}/usr/lib/systemd/system/incus-startup.service
install -m 0644 %{SOURCE7} %{buildroot}/usr/lib/systemd/system/incus-user.service
install -m 0644 %{SOURCE8} %{buildroot}/usr/lib/systemd/system/incus-user.socket

# Install sysctl config
mkdir -p %{buildroot}/usr/lib/sysctl.d
echo 'fs.inotify.max_user_instances = 1024' > %{buildroot}/usr/lib/sysctl.d/10-incus-inotify.conf

# Install sysusers config
mkdir -p %{buildroot}/usr/lib/sysusers.d
echo 'g incus-admin -' > %{buildroot}/usr/lib/sysusers.d/incus.conf
echo 'g incus -' >> %{buildroot}/usr/lib/sysusers.d/incus.conf

# Install tmpfiles config
mkdir -p %{buildroot}/usr/lib/tmpfiles.d
echo 'd /home/incus/cache 0700 root root - -' > %{buildroot}/usr/lib/tmpfiles.d/incus.conf
echo 'd /home/incus/logs 0700 root root - -' >> %{buildroot}/usr/lib/tmpfiles.d/incus.conf
echo 'd /home/incus/storage-pools 0711 root root - -' >> %{buildroot}/usr/lib/tmpfiles.d/incus.conf

# Create necessary directories
mkdir -p %{buildroot}/home/incus/logs
mkdir -p %{buildroot}/home/incus/cache
mkdir -p %{buildroot}/home/incus/storage-pools
mkdir -p %{buildroot}/home/incus/guestapi
mkdir -p %{buildroot}/home/incus/backups
mkdir -p %{buildroot}/home/incus/containers
mkdir -p %{buildroot}/home/incus/containers-snapshots
mkdir -p %{buildroot}/home/incus/database
mkdir -p %{buildroot}/home/incus/devices
mkdir -p %{buildroot}/home/incus/disks
mkdir -p %{buildroot}/home/incus/images
mkdir -p %{buildroot}/home/incus/networks
mkdir -p %{buildroot}/home/incus/run
mkdir -p %{buildroot}/home/incus/security
mkdir -p %{buildroot}/home/incus/shmounts
mkdir -p %{buildroot}/home/incus/storage-pools
mkdir -p %{buildroot}/home/incus/virtual-machines
mkdir -p %{buildroot}/home/incus/virtual-machines-snapshots
mkdir -p %{buildroot}/var/log/incus
mkdir -p %{buildroot}/var/lib/incus

# Install documentation and license
mkdir -p %{buildroot}/usr/share/doc/incus
install -m 0644 CODE_OF_CONDUCT.md %{buildroot}/usr/share/doc/incus
install -m 0644 CONTRIBUTING.md %{buildroot}/usr/share/doc/incus
install -m 0644 README.md %{buildroot}/usr/share/doc/incus
install -m 0644 SECURITY.md %{buildroot}/usr/share/doc/incus

mkdir -p %{buildroot}/usr/share/licenses/incus
install -m 0644 COPYING %{buildroot}/usr/share/licenses/incus

# Install additional files
mkdir -p %{buildroot}/usr/share/bash-completion/completions
install -m 0644 %{SOURCE3} %{buildroot}/usr/share/bash-completion/completions/incus

mkdir -p %{buildroot}/usr/share/zsh/site-functions
install -m 0644 %{SOURCE2} %{buildroot}/usr/share/zsh/site-functions/_incus

mkdir -p %{buildroot}/etc/dnsmasq.d
echo '# Tell any system-wide dnsmasq instance to make sure to bind to interfaces
# instead of listening on 0.0.0.0
# WARNING: changes to this file will get lost if incus is removed.
bind-interfaces
except-interface=incusbr0' > %{buildroot}/etc/dnsmasq.d/incus.conf

%files
/usr/libexec/incus/incusd
/usr/bin/incus
/usr/bin/incus-agent
/usr/bin/incus-benchmark
/usr/bin/incus-migrate
/usr/bin/bin.linux.incus-migrate.x86_64
/usr/libexec/incus/incus-simplestreams
/usr/libexec/incus/incus-user
/usr/libexec/incus/lxc-to-incus
/usr/libexec/incus/lxd-to-incus
/usr/bin/fuidshift
/usr/lib/systemd/system/incus.service
/usr/lib/systemd/system/incus.socket
/usr/lib/systemd/system/incus-startup.service
/usr/lib/systemd/system/incus-user.service
/usr/lib/systemd/system/incus-user.socket
/usr/lib/sysctl.d/10-incus-inotify.conf
/usr/lib/sysusers.d/incus.conf
/usr/lib/tmpfiles.d/incus.conf
/usr/share/doc/incus/CODE_OF_CONDUCT.md
/usr/share/doc/incus/CONTRIBUTING.md
/usr/share/doc/incus/README.md
/usr/share/doc/incus/SECURITY.md
/usr/share/licenses/incus/COPYING
/usr/share/bash-completion/completions/incus
/usr/share/zsh/site-functions/_incus
/etc/dnsmasq.d/incus.conf
%dir /home/incus/logs
%dir /home/incus/cache
%dir /home/incus/guestapi
%dir /home/incus/backups
%dir /home/incus/containers
%dir /home/incus/containers-snapshots
%dir /home/incus/database
%dir /home/incus/devices
%dir /home/incus/disks
%dir /home/incus/images
%dir /home/incus/networks
%dir /home/incus/run
%dir /home/incus/security
%dir /home/incus/shmounts
%dir /home/incus/storage-pools
%dir /home/incus/virtual-machines
%dir /home/incus/virtual-machines-snapshots
/var/log/incus
/var/lib/incus
/root/incus_config.yaml
/etc/profile.d/incus.sh
/etc/logrotate.d/incus
/home/incus/openssl.cnf

%license COPYING

%pre
getent group incus-admin >/dev/null || groupadd -r incus-admin
getent group incus >/dev/null || groupadd -r incus
systemd-sysusers --replace=/usr/lib/sysusers.d/incus.conf - <<SYSTEMD_INLINE_EOF || : 
g incus-admin -
g incus - 
SYSTEMD_INLINE_EOF

systemd-tmpfiles --replace=/usr/lib/tmpfiles.d/incus.conf --create - <<SYSTEMD_INLINE_EOF || : 
d /home/incus/cache 0700 root root - -
d /home/incus/logs 0700 root root - -
d /home/incus 0711 root root - -
d /home/incus/storage-pools 0711 root root
SYSTEMD_INLINE_EOF

%post

# Prepare certificate:
if [ $1 -eq 1 ]; then
    if [ ! -f /home/incus/server.key ] || [ ! -f /home/incus/server.crt ];then
        export HOSTNAME=$(hostname)
        openssl req -x509 -newkey ec:<(openssl ecparam -name secp384r1) -keyout /home/incus/server.key -out /home/incus/server.crt -days 3650 -nodes -config /home/incus/openssl.cnf -extensions req_ext
    fi
fi

####
if [ $1 -eq 1 ]; then
    # Initial install only
    systemctl daemon-reload
    systemctl enable incus.socket
    systemctl start incus.socket

    if [ ! -L /var/lib/incus/unix.socket ]; then
        mkdir -p /var/lib/incus
        ln -s /home/incus/unix.socket /var/lib/incus/unix.socket
    fi

    # Stop named-chroot or we can't configure incus properly
    /usr/bin/systemctl stop named-chroot &>/dev/null || :

    # Initialize Incus
    /usr/bin/incus network create incusbr0 ipv4.address=auto ipv6.address=auto
    /usr/bin/incus storage create default dir source=/home/incus/storage-pools/default
    /usr/bin/incus admin init --preseed < /root/incus_config.yaml
    /usr/bin/incus storage set default source=/home/incus/storage-pools/default

    /usr/bin/systemctl condrestart named-chroot &>/dev/null || :
elif [ $1 -ge 2 ]; then
    # Upgrade: only reload systemd definitions
    systemctl daemon-reload
fi

%preun
if [ $1 -eq 0 ] && [ -x "/usr/lib/systemd/systemd-update-helper" ]; then 
    /usr/lib/systemd/systemd-update-helper remove-system-units incus.socket || : 
    /usr/lib/systemd/systemd-update-helper remove-system-units incus.service || : 
    /usr/lib/systemd/systemd-update-helper remove-system-units incus-startup.service || : 
    /usr/lib/systemd/systemd-update-helper remove-system-units incus-user.socket || : 
    /usr/lib/systemd/systemd-update-helper remove-system-units incus-user.service || : 
fi 

if [ $1 -eq 0 ]; then
    systemctl daemon-reload
    systemctl stop incus.socket
    systemctl disable incus.socket
fi

%postun
if [ $1 -ge 1 ]; then
    systemctl daemon-reload
    # No reload or restart of incus.socket or incus.service
fi

%changelog

* Mon Apr 28 2025 Michael Stauber <mstauber@solarspeed.net> - 6.12.0-1
- Updated to v6.12.0

* Sun Mar 30 2025 Michael Stauber <mstauber@solarspeed.net> - 6.11.0-1
- Updated to v6.11.0

* Sun Mar 09 2025 Michael Stauber <mstauber@solarspeed.net> - 6.10.1-1
- Updated to v6.10.1

* Sat Jan 25 2025 Michael Stauber <mstauber@solarspeed.net> - 6.9.0-1
- Updated to v6.9

* Fri Dec 13 2024 Michael Stauber <mstauber@solarspeed.net> - 6.8.0-1
- Updated to v6.8

* Wed Nov 20 2024 Michael Stauber <mstauber@solarspeed.net> - 6.7.0-1
- Updated to v6.7

* Mon Oct 07 2024 Michael Stauber <mstauber@solarspeed.net> - 6.6.0-1
- Updated to v6.6
- We now use our own incus-migrate as bin.linux.incus-migrate.x86_64

* Sun Oct 06 2024 Michael Stauber <mstauber@solarspeed.net> - 6.5.0-6
- Set CGO_ENABLED=0 specifically for the build of 'incus-agent' so that
  it is built statically linked. Otherwise we're in a world of hurt 
  with missing dependencies for it depending on the used VM OS.
- Also compiled 'incus-migrate' the same way: Statically linked.

* Fri Oct 04 2024 Michael Stauber <mstauber@solarspeed.net> - 6.5.0-5
- Dropped qemu-runas-fix.patch again for usage with COPR QEMU Spice
- Dropped qemu_virtio-fs.patch
- Left both patches in the Specfile for inclusion in the SRPM.

* Thu Oct 03 2024 Michael Stauber <mstauber@solarspeed.net> - 6.5.0-4
- Dropped qemu-runas-fix.patch for now
- Added qemu_virtio-fs.patch to force QEMU to NOT use 9p for agent
  installs but to use virtio-fs instead.
- Fixed wrong Incusd shutdown call in incus-startup.service

* Thu Oct 03 2024 Michael Stauber <mstauber@solarspeed.net> - 6.5.0-3
- Added qemu-runas-fix.patch to change QEMU call from -runas to
  -run-with user=...' instead to make it work with newer QEMU versions

* Wed Oct 02 2024 Michael Stauber <mstauber@solarspeed.net> - 6.5.0-2
- Fixed Environment variable INCUS_EDK2_PATH in incus.service
- BuildRequires updated

* Mon Sep 09 2024 Michael Stauber <mstauber@solarspeed.net> - 6.5.0-1
- Updated to v6.5

* Wed Jul 31 2024 Michael Stauber <mstauber@solarspeed.net> - 6.3.0-3
- Added missing /home/incus/ subdirectories
- Added server.key and server.crt creation to post-install

* Wed Jul 31 2024 Michael Stauber <mstauber@solarspeed.net> - 6.3.0-2
- Updated 6.3.0 build with paths changed to /home/incus where appropriate
- Added /usr/bin/bin.linux.incus-migrate.x86_64
- Added /root/incus_config.yaml
- Added /etc/profile.d/incus.sh
- Added /etc/logrotate.d/incus
- Note: Creation of VMs fails due to "QEMU failed to run feature checks"

* Tue Jul 30 2024 Michael Stauber <mstauber@solarspeed.net> - 6.3.0-1
- Initial package for Incus 6.3.0
